function [outinit]=initDIR()
%--------------------------------------------------------------------------
% Initialisation des parametres physiques et numériques
%--------------------------------------------------------------------------
% outinit : structure contenant les champs suivants :
%
% exemple     : choix de l'exemple : 
%               1-> Cavité entrainée
%               2-> Allée de Von Karman avec un écoulement de Poiseuille 
%                   en entrée/sortie.
% nu          : viscosité
% dt          : pas de temps; si dt=[] alors choix automatique de dt
% nbiter      : nb d'iterations en temps
% type_print  : type d'affichage : 0-> pas de sortie graphique
%                                  1-> vitesse; 2-> pression
% save_name   : répertoire de sauvegarde pour les resultats
% iterverbose : mode verbeux dans les iterations
%--------------------------------------------------------------------------
    
    exemple=1;
    nu=0.001;               
    dt=[];                  
    nbiter=150;             
    type_print=1;           
    save_name='Results_NS'; 
    iterverbose=false;     
    
    outinit=struct('exemple',exemple,'nu',nu,'dt',dt,'nbiter',nbiter,...
        'type_print',type_print,'save_name',save_name,...
        'iterverbose',iterverbose);
end
