#include "mex.h"
#include "matrix.h"
#include "stdio.h"
#include "stdlib.h"
#include <iostream>
#include <math.h>
#include <cstring>

/* structure liste*/
typedef struct chaine_ {
      int val;
      struct chaine_ * suivant;
}  chaine;

chaine *add(chaine * head, int valeur)
{
      chaine * test = new chaine();
      test->suivant= head;
      test->val=valeur;
      return test;
}

chaine * del(chaine * head)
{
      chaine * cell;
      cell=head->suivant;
      delete head;
      return cell;
}
/* fin structure liste*/

/*---------------------------
  fonction intersection.cpp
  -------------------------*/
int* intersection(int * k1, int *k2,int long_k1, int long_k2){

      int * k; 
      int compteur=0, i, j;

      chaine * compare=new chaine();
      compare->val=0;
      compare->suivant=NULL;

      for (i=0;i<long_k1;i=i+1) {
         for (j=0;j<long_k2;j=j+1) {
              if (k1[i]==k2[j]) {
                 compteur=compteur+1;
                 if (compteur==1){
                    compare->val=k1[i];
                 }
                 else{
                    compare=add(compare,k1[i]);
                 }
              }
         }
      }

      k=new int[compteur+1];
      for (i=0;i<compteur;i=i+1){
         k[i+1]=compare->val;
         compare = del(compare);
      }
      k[0]=compteur;
      compare=NULL;
      return k;
}

/*---------------------------
  fonction intersec.cpp
  ---------------------------*/
double * intersec(double M[2], bool sommet, int j,int j1,int j2,int j3,double a1,double a2,double a3,double **v1,int **t1,double Uxm,double Uym,int *isupp1, const int *tsupp1)
{
      double* sortie_de_la_fonction = new double[8];
      double epsil = 1e-10, d=0, lambda1=0, lambda2=0, lambda3=0, e1=0, e2=0, e3=0;
      double Um[2], Q[2], P1[2], P2[2], P3[2], S[2];
      int *kMset, *k1, *k2;
      int j_tmp;
      int l=0, long_kMset =0, long_k1=0, long_k2=0, val_inf_km, val_sup_km, val_inf_k1, val_sup_k1, val_inf_k2, val_sup_k2, temp;
      bool trouve=false;

      Q[0]=-100000;
      Q[1]=-100000;
      P1[0]=0;
      P1[1]=0;
      P2[0]=0;
      P2[1]=0;
      P3[0]=0;
      P3[1]=0;
      Um[0]=Uxm;
      Um[1]=Uym;

     // creation des vecteur kMset, k1 et k2 suivant la valeur de sommet

      if (sommet) {
         val_inf_km = isupp1[j]+1;
         val_sup_km = isupp1[j+1];
         long_kMset=val_sup_km-val_inf_km+1;
         kMset=new int[long_kMset];
         k1 = new int;
         k2 = new int;
      }
      else {
         val_inf_k1 = isupp1[j1]+1;
         val_sup_k1 = isupp1[j1+1];
         val_inf_k2 = isupp1[j2]+1;
         val_sup_k2 = isupp1[j2+1];
         long_k1=val_sup_k1-val_inf_k1+1;
         long_k2=val_sup_k2-val_inf_k2+1;
         k1 = new int[long_k1];
         k2 = new int[long_k2];
      }

      if (sommet) {
         temp=isupp1[j]+1;
         for (int i=0; i<long_kMset;i=i+1) {
             kMset[i]=tsupp1[temp+i];
         }
      }
      else {
         temp=isupp1[j1]+1;
         for (int i=0; i<long_k1;i=i+1) {
             k1[i]=tsupp1[temp+i];
         }
         temp=isupp1[j2]+1;

         for (int i=0; i<long_k2;i=i+1) {
             k2[i]=tsupp1[temp+i];
         }
         kMset = intersection(k1,k2,long_k1, long_k2);
         long_kMset=kMset[0];

         for (int indice=0;indice<long_kMset;indice=indice+1) {
             kMset[indice]=kMset[indice+1];
         }
      }  // fin si

      while ((trouve==false) && (l<long_kMset)) {
         S[0]=M[0]+Um[0];
         S[1]=M[1]+Um[1];
         if (sqrt(pow(Um[0],2)+pow(Um[1],2))<epsil) {
            Q[0]=M[0];
            Q[1]=M[1];
            trouve=true;
         }
         else if (sommet) {

            //cas ou M est un sommet du triangle kMset
            P1[0]=v1[ t1[ kMset[l] ] [0] ] [0];
            P1[1]=v1[ t1[ kMset[l] ] [0] ] [1];
            P2[0]=v1[t1[kMset[l]][1]][0];
            P2[1]=v1[t1[kMset[l]][1]][1];
            P3[0]=v1[t1[kMset[l]][2]][0];
            P3[1]=v1[t1[kMset[l]][2]][1];

            //calcul des coordonnées barycentriques de S dans [P1,P2,P3]
            d=((P2[0]-P1[0])*(P3[1]-P1[1]))-((P2[1]-P1[1])*(P3[0]-P1[0]));
            lambda1=(((P2[0]-S[0])*(P3[1]-P2[1]))-((P2[1]-S[1])*(P3[0]-P2[0])))/d;
            lambda2=(((P3[0]-S[0])*(P1[1]-P3[1]))-((P3[1]-S[1])*(P1[0]-P3[0])))/d;
            lambda3=1-lambda1-lambda2;

            //test si le triangle kj[l] est traversé par u
            if ((j==t1[kMset[l]][0]) && (lambda2>=0) && (lambda3>=0)) {
               a1=lambda2/(lambda2+lambda3);
               a2=1-a1;
               a3=0;
               j1=t1[kMset[l]][1];
               j2=t1[kMset[l]][2];
               j3=j;
               trouve=true;
            }
            else if((j==t1[kMset[l]][1]) && (lambda1>=0) && (lambda3>=0)) {
               a1=lambda3/(lambda1+lambda3);
               a2=1-a1;
               a3=0;
               j1=t1[kMset[l]][2];
               j2=t1[kMset[l]][0];
               j3=j;
               trouve=true;
             }
             else if((j==t1[kMset[l]][2]) && (lambda1>=0) && (lambda2>=0)) {
               a1=lambda1/(lambda1+lambda2);
               a2=1-a1;
               a3=0;
               j1=t1[kMset[l]][0];
               j2=t1[kMset[l]][1];
               j3=j;
               trouve=true;
             }
         }
         else {  //cas où M n'est pas un sommet du triangle kM[l]

               // pour remplacer le find(j3==j1)... de matlab
               if (((t1[kMset[l]][0]==j1) && (t1[kMset[l]][1]==j2)) || ((t1[kMset[l]][1]==j1) && (t1[kMset[l]][0]==j2))) {
                  j3=t1[kMset[l]][2];
               }
               else if (((t1[kMset[l]][0]==j1) && (t1[kMset[l]][2]==j2)) || ((t1[kMset[l]][2]==j1) && (t1[kMset[l]][0]==j2))) {
                  j3=t1[kMset[l]][1];
               }
               else if (((t1[kMset[l]][1]==j1) && (t1[kMset[l]][2]==j2)) || ((t1[kMset[l]][2]==j1) && (t1[kMset[l]][1]==j2))) {
                  j3=t1[kMset[l]][0];
               }

               P1[0]=v1[j1] [0];
               P1[1]=v1[j1] [1];
               P2[0]=v1[j2][0];
               P2[1]=v1[j2][1];
               P3[0]=v1[j3][0];
               P3[1]=v1[j3][1];

               //calcul des coordonnées barycentriques de S dans (P1,M,P3)
               d=((P1[0]-M[0])*(P3[1]-M[1]))-((P1[1]-M[1])*(P3[0]-M[0]));
               e1=Um[0]*(P1[1]-M[1])-Um[1]*(P1[0]-M[0]);
               e2=Um[0]*(P2[1]-M[1])-Um[1]*(P2[0]-M[0]);
               e3=Um[0]*(P3[1]-M[1])-Um[1]*(P3[0]-M[0]);
               lambda1=e3/d;
               lambda3=-e1/d;

               if ((lambda1>=0) && (lambda3>=0)) {
                  a1=lambda1/(lambda1+lambda3);
                  a2=1-a1;
                  a3=0;
                  j_tmp=j2;
                  j2=j3;
                  j3=j_tmp;
                  trouve=true;
               }
               else {

                  //calcul des coordonnées barycentriques dans (M,P2,P3)
                  d=((P2[0]-M[0])*(P3[1]-M[1]))-((P2[1]-M[1])*(P3[0]-M[0]));
                  lambda2=e3/d;
                  lambda3=-e2/d;
                  if ((lambda2>=0) && (lambda3>=0)) {
                     a1=lambda2/(lambda2+lambda3);
                     a2=1-a1;
                     a3=0;
                     j_tmp=j1;
                     j1=j2;
                     j2=j3;
                     j3=j_tmp;
                     trouve=true;
                  }
               }

         }

         if (trouve) {
            Q[0]=a1*v1[j1][0]+a2*v1[j2][0]+a3*v1[j3][0];
            Q[1]=a1*v1[j1][1]+a2*v1[j2][1]+a3*v1[j3][1];
         }
         l=l+1;

      }  // fin while

      sortie_de_la_fonction[0]=Q[0];
      sortie_de_la_fonction[1]=Q[1];
      sortie_de_la_fonction[2]=j1;
      sortie_de_la_fonction[3]=j2;
      sortie_de_la_fonction[4]=j3;
      sortie_de_la_fonction[5]=a1;
      sortie_de_la_fonction[6]=a2;
      sortie_de_la_fonction[7]=a3;
      delete [] kMset;
      kMset=NULL;
      delete [] k1;
      k1=NULL;
      delete [] k2;
      k2=NULL;
      return sortie_de_la_fonction;

} // fin de la fonction intersec


/*------------------------------
  fonction convection.cpp
--------------------------------*/
double * convection(int nv1, double * Vx, double * Vy,double * Ux,double * Uy,double dt, double** v1,int **t1,int *isupp1, const int *tsupp1)
{
      double epsil = 1e-10, vartemp,vartemp1;
      int j1=0, j2=0, j3=0, jM=0, j=0;
      double *X, *Y;
      double *sortie;
      double * sortie_intersec; //=new double[8];
      double a1=0, a2=0, a3=0, tau=0, Q[2], M[2], normUm=0, Uxm=0, Uym=0, Vxm=0, Vym=0, r=0, P1[2], P2[2], P3[2];
      double d=0;
      bool sommet=true;

      sortie=new double[2*nv1];// on met dedans X puis Y
      X=new double[nv1];
      Y=new double[nv1];

      for (j=0;j<nv1;j=j+1) {
          X[j]=0;
          Y[j]=0;
          sortie[j]=0;
          sortie[j+nv1]=0;
      }

      M[0]=0;
      M[1]=0;
      P1[0]=0;
      P1[1]=0;
      P2[0]=0;
      P2[1]=0;
      P3[0]=0;
      P3[1]=0;

      for (j=0;j<nv1;j=j+1) {
          Uxm=Ux[j];
          Uym=Uy[j];
          Vxm=Vx[j];
          Vym=Vy[j];
          normUm=Uxm*Uxm+Uym*Uym;
          M[0]=v1[j][0];
          M[1]=v1[j][1];
          Q[0]=M[0];
          Q[1]=M[1];
          jM=j;
          sommet=true;
          j1=0;
          j2=0;
          j3=0;
          a1=0;
          a2=0;
          a3=0;
          tau=0;

          while ((tau<dt) && (normUm>epsil)) {
                sortie_intersec=intersec(M,sommet,jM,j1,j2,j3,a1,a2,a3,v1,t1,-1*Uxm,-1*Uym,isupp1,tsupp1);
                Q[0]=sortie_intersec[0];
                Q[1]=sortie_intersec[1];
                j1=(int)sortie_intersec[2];
                j2=(int)sortie_intersec[3];
                j3=(int)sortie_intersec[4];
                a1=sortie_intersec[5];
                a2=sortie_intersec[6];
                a3=sortie_intersec[7];

                delete[] sortie_intersec;
                sortie_intersec=NULL;

                if ((Q[0]==-100000) && (Q[1]==-100000)) {
                   Q[0]=M[0];
                   Q[1]=M[1];
                   break;
                }
                else {
                   sommet=false;
                   r=-(Uxm*(Q[0]-M[0])+Uym*(Q[1]-M[1]))/normUm;
                   if ((tau+r)>dt) {
                      Q[0]=M[0]-Uxm*(dt-tau);
                      Q[1]=M[1]-Uym*(dt-tau);
                      P1[0]=v1[j1][0];
                      P1[1]=v1[j1][1];
                      P2[0]=v1[j2][0];
                      P2[1]=v1[j2][1];
                      P3[0]=v1[j3][0];
                      P3[1]=v1[j3][1];
                      d=((P1[0]-P3[0])*(P2[1]-P3[1]))-((P1[1]-P3[1])*(P2[0]-P3[0]));
                      a1=(((Q[0]-P3[0])*(P2[1]-P3[1]))-((Q[1]-P3[1])*(P2[0]-P3[0])))/d;
                      a2=-1*(((Q[0]-P3[0])*(P1[1]-P3[1]))-((Q[1]-P3[1])*(P1[0]-P3[0])))/d;
                      a3=1-a1-a2;
                      tau=dt;
                   }
                   else {
                      tau=tau+r;
                      vartemp=fabs(a1-1);
                      vartemp1=fabs(a2-1);
                      if (fabs(a1-1)<epsil) {
                         jM=j1;
                         sommet=true;
                      }
                      else if (fabs(a2-1)<epsil) {
                         jM=j2;
                         sommet=true;
                      }

                   } // fin si (tau+r)>dt

                }  // fin si

                // Interpolation de la vitesse
                Uxm=a1*Ux[j1]+a2*Ux[j2]+a3*Ux[j3];
                Uym=a1*Uy[j1]+a2*Uy[j2]+a3*Uy[j3];
                Vxm=a1*Vx[j1]+a2*Vx[j2]+a3*Vx[j3];
                Vym=a1*Vy[j1]+a2*Vy[j2]+a3*Vy[j3];
                normUm=Uxm*Uxm+Uym*Uym;
                M[0]=Q[0];
                M[1]=Q[1];

          }  // fin while

          X[j]=Vxm;
          Y[j]=Vym;

      }  // fin pour j

      for (int ind=0;ind<nv1;ind+=1) {
          sortie[ind]=X[ind];
          sortie[ind+nv1]=Y[ind];
      }

      delete X;
      X=NULL;
      delete Y;
      Y=NULL;
      return sortie;

} // fin de la fonction convection

/*-----------------------
  mexfiles convect.cpp
-------------------------*/
void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[])	 
{
      int nv1, **t1, *isupp1, *tsupp1, ind2=0, dim;
      int n_t1, n_v1, m_t1, m_v1, m_isupp1, m_tsupp1;
      double *Vx, *Vy, *Ux, *Uy, **v1, *v1_temp, *t1_temp, *sortie, *isupp1_temp, *tsupp1_temp;
      double dt;

      nv1=(int)mxGetScalar(prhs[0]);
      Vx=(double *)mxGetPr(prhs[1]);
      Vy=(double *)mxGetPr(prhs[2]);
      Ux=(double *)mxGetPr(prhs[3]);
      Uy=(double *)mxGetPr(prhs[4]);
      dt=mxGetScalar(prhs[5]);
      v1_temp=(double *)mxGetPr(prhs[6]);
      t1_temp=(double *)mxGetPr(prhs[7]);
      isupp1_temp=(double *)mxGetPr(prhs[8]);
      tsupp1_temp=(double *)mxGetPr(prhs[9]);

      n_v1=(int)mxGetN(prhs[6]);
      m_v1=(int)mxGetM(prhs[6]);
      n_t1=(int)mxGetN(prhs[7]);
      m_t1=(int)mxGetM(prhs[7]);
      m_isupp1=(int)mxGetM(prhs[8]);
      m_tsupp1=(int)mxGetM(prhs[9]);

      isupp1=new int[m_isupp1];
      tsupp1=new int[m_tsupp1];

      // On retire 1 aux tableaux d'entiers : en matlab, les indices des tableaux commencent à 1
      // alors qu'en C++ ils commencent à 0 ...

      // astuce (bidouille) pour passer les vecteurs d'entier, et les matrices....
      isupp1[0]=0;
      for (int ind=1;ind<m_isupp1;ind=ind+1) {
          isupp1[ind]=(int)isupp1_temp[ind]-1;
      }

      for (int ind=0;ind<m_tsupp1;ind=ind+1) {
          tsupp1[ind]=(int)tsupp1_temp[ind]-1;
      }

      dim=2*nv1;
      plhs[0] = mxCreateDoubleMatrix(dim, 1,mxREAL);

      v1=new double*[m_v1];
      t1=new int*[m_t1];

      for (int ind=0;ind<m_v1;ind=ind+1) {
          v1[ind]=new double[n_v1];
      }

      for (int ind=0;ind<m_t1;ind=ind+1) {
          t1[ind]=new int[n_t1];
      }

      for (int ind=0;ind<n_v1;ind=ind+1) {
          for (int ind1=0;ind1<m_v1;ind1=ind1+1) {
              v1[ind1][ind]=v1_temp[ind2];
              ind2=ind2+1;
          }
      }
      ind2=0;

      for (int ind=0;ind<n_t1;ind=ind+1) {
          for (int ind1=0;ind1<m_t1;ind1=ind1+1) {
              t1[ind1][ind]=(int)t1_temp[ind2]-1;
              ind2=ind2+1;
          }
      }

      // convection
      sortie=convection(nv1,Vx,Vy,Ux,Uy,dt,v1,t1,isupp1,tsupp1);

      delete[] isupp1;
      isupp1=NULL;
      delete[] tsupp1;
      tsupp1=NULL;

      for (int ind=0;ind<m_v1;ind=ind+1) {
          delete [] v1[ind];
          v1[ind]=NULL;
      }

      delete [] v1;
      v1=NULL;
      for (int ind=0;ind<m_t1;ind=ind+1) {
          delete [] t1[ind];
          t1[ind]=NULL;
      }

      delete[] t1;
      t1=NULL;
      memcpy(mxGetPr(plhs[0]),sortie, dim*sizeof(double));
      delete [] sortie;
      sortie=NULL;

}
