function [node,edge]=obstacle(node,edge,pas_h,pxy,lgxy,angle)
%--------------------------------------------------------------------------
% Ajout d'un obstacle (ellipse) dans le domaine défini par (node,edge)
%--------------------------------------------------------------------------
% node  : coordonnées des noeuds du bord du domaine
% edge  : numéros des noeuds définissant les aretes
% pas_h : taille du maillage
% pxy   : position (x,y) du centre de l'ellipse
% lgxy  : longueurs des demi-axes 
% angle : orientation de l'obstacle
%--------------------------------------------------------------------------
n = size(node,1);

% Discretisation automatique de l'ellipse

N= floor(2*pi*sqrt((lgxy(1).^2+lgxy(2)^2)/2)/pas_h);
theta = linspace(0,2*pi,N+1); 
theta=theta(1:N);
x = lgxy(1)*cos(theta);
y = lgxy(2)*sin(theta);
Rotation=[cos(angle) -sin(angle); sin(angle) cos(angle)]*[x; y];
x=pxy(1)+Rotation(1,:); 
y=pxy(2)+Rotation(2,:);
     
% Construction de la structure pour le mailleur mesh2d
node = [node; x' y'];
edge = [edge; (n+1:n+N-1)', (n+2:n+N)'; n+N, n+1];

end