function plotsol(t1,t2,v1,v2,Ux,Uy,Pr,tps,type_print)
    
    set(gcf,'Color',[1 1 1]);  % Figure's background color = white
    clf;
    colormap('jet');
    
    if type_print==1    
        
        %------------------------
        % Affichage de la vitesse
        %------------------------
        
        % Module de la vitesse
        mod_U=sqrt(Ux.^2+Uy.^2);
        patch('faces',t2(:,1:3),'vertices',v2(:,1:2),'FaceVertexCData',...
              mod_U,'facecolor','interp','edgecolor','none');
        hold on
        
        % Champ de vitesse
        quiver(v1(:,1),v1(:,2),Ux(1:size(v1,1)),Uy(1:size(v1,1)));
        message=strcat('vitesse à t=',num2str(tps));
        hold off;
        
    else
        %-------------------------
        % Affichage de la pression
        %-------------------------
        
        patch('faces',t1(:,1:3),'vertices',v1(:,1:2),'FaceVertexCData',...
              Pr,'facecolor','interp','edgecolor','black');
        message=strcat('pression à t=',num2str(tps));
        
    end

    axis image
    colorbar('northoutside');
    title(message)
    drawnow
    
end