function [ucl,tdep]=menu_cl(Choixpb)

global gcl timedep

% Valeur par defaut

if Choixpb==1 ,
    gcl=num2cell(zeros(4,2));
    for i=1:8, gcl{i}=num2str(gcl{i}); end;
    gcl{3,1}='1';
    timedep=false;
else
    gcl=num2cell(zeros(4,2));
    for i=1:8, gcl{i}=num2str(gcl{i}); end;
    gcl{4,1}='sin(pi*t/T)*6*y.*(H-y)/(H^2)';
    gcl{2,1}='sin(pi*t/T)*6*y.*(H-y)/(H^2)';
    timedep=true;
end

hFigure = figure('Name', 'NS2D', 'MenuBar','none','numbertitle','off',...
                 'units','pixels','position',[600 600 485 700]);
                 
bgColor = get(hFigure,'Color');

uicontrol('Parent',hFigure,'style','text',...
   'BackgroundColor',bgColor,...
   'units','normalized','position',[0 0.92 1 0.05],...
   'string','Solveur Navier-Stokes 2D','FontSize',16);

%--------------------------------------------------------------------------
% Construction du menu 'Conditions limites'
%--------------------------------------------------------------------------

hbgp = uibuttongroup('Parent',hFigure,'units','normalized',...
    'Position',[0.05 0.1 0.9 0.8],...
    'BackgroundColor',bgColor,...
    'Title','Conditions limites',...
    'FontSize',14);
       
hp0=uicontrol('Parent',hbgp,'style','checkbox',...
    'BackgroundColor',[0.75 0.75 0.75],...
    'string','CL dépendantes du temps','units','normalized',...
    'position',[0.02 0.93 0.5 0.05],'callback',@majtimedep);

if Choixpb~=1,
    set(hp0,'Value',1);
end;

hp1=uipanel('Parent',hbgp,'Title','Bord 1 {y=0} :','FontSize',11,...
    'Title','Bord 1 {y=0} :','BackgroundColor',bgColor,'BorderWidth',0,...
    'units','normalized','position',[0 0.66 1 0.24]);

uicontrol('Parent',hp1,'style','text','BackgroundColor',bgColor,...
    'string','ux =','units','normalized','position',[0 0.64 0.1 0.2]);

uicontrol('Parent',hp1,'style','edit',...
    'units','normalized','position',[0.09 0.64 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{1,1},'callback',{@majuxy,1,1});

uicontrol('Parent',hp1,'style','text','BackgroundColor',bgColor,...
    'string','uy =','units','normalized','position',[0 0.32 0.1 0.2]);

uicontrol('Parent',hp1,'style','edit',...
    'units','normalized','position',[0.09 0.32 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{1,2},'callback',{@majuxy,1,2});

%--------------------------------------------------------------------------
hp2=uipanel('Parent',hbgp,'Title','Bord 1 {y=0} :','FontSize',11,...
    'Title','Bord 2 {x=L} :','BackgroundColor',bgColor,'BorderWidth',0,...
    'units','normalized','position',[0 0.44 1 0.24]);

uicontrol('Parent',hp2,'style','text','BackgroundColor',bgColor,...
    'string','ux =','units','normalized','position',[0 0.64 0.1 0.2]);

uicontrol('Parent',hp2,'style','edit',...
    'units','normalized','position',[0.09 0.64 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{2,1},'callback',{@majuxy,2,1});

uicontrol('Parent',hp2,'style','text','BackgroundColor',bgColor,...
    'string','uy =','units','normalized','position',[0 0.32 0.1 0.2]);

uicontrol('Parent',hp2,'style','edit',...
    'units','normalized','position',[0.09 0.32 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{2,2},'callback',{@majuxy,2,2});

%--------------------------------------------------------------------------

hp3=uipanel('Parent',hbgp,'Title','Bord 1 {y=0} :','FontSize',11,...
    'Title','Bord 3 {y=H} :','BackgroundColor',bgColor,'BorderWidth',0,...
    'units','normalized','position',[0 0.22 1 0.24]);

uicontrol('Parent',hp3,'style','text','BackgroundColor',bgColor,...
    'string','ux =','units','normalized','position',[0 0.64 0.1 0.2]);

uicontrol('Parent',hp3,'style','edit',...
    'units','normalized','position',[0.09 0.64 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{3,1},'callback',{@majuxy,3,1});

uicontrol('Parent',hp3,'style','text','BackgroundColor',bgColor,...
    'string','uy =','units','normalized','position',[0 0.32 0.1 0.2]);

uicontrol('Parent',hp3,'style','edit',...
    'units','normalized','position',[0.09 0.32 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{3,2},'callback',{@majuxy,3,2});

%--------------------------------------------------------------------------

hp4=uipanel('Parent',hbgp,'Title','Bord 1 {y=0} :','FontSize',11,...
    'Title','Bord 4 {x=0} :','BackgroundColor',bgColor,'BorderWidth',0,...
    'units','normalized','position',[0 0 1 0.24]);

uicontrol('Parent',hp4,'style','text','BackgroundColor',bgColor,...
    'string','ux =','units','normalized','position',[0 0.64 0.1 0.2]);

uicontrol('Parent',hp4,'style','edit',...
    'units','normalized','position',[0.09 0.64 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{4,1},'callback',{@majuxy,4,1});

uicontrol('Parent',hp4,'style','text','BackgroundColor',bgColor,...
    'string','uy =','units','normalized','position',[0 0.32 0.1 0.2]);

uicontrol('Parent',hp4,'style','edit',...
    'units','normalized','position',[0.09 0.32 0.9 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',gcl{4,2},'callback',{@majuxy,4,2});

%--------------------------------------------------------------------------
uicontrol('Parent',hFigure,'style','pushbutton',...
    'units','pixels',...
    'position',[212 20 60 30],...
    'string','OK',...
    'callback','close;');

uiwait

ucl=gcl; tdep=timedep;

%--------------------------------------------------------------------------
function majuxy(source,eventdata,i,j)
  gcl{i,j}=get(source,'String');
end
function majtimedep(source,eventdata,i,j)
  if (get(source,'Value') == get(source,'Max'))
   % Checkbox is checked-take approriate action
   timedep=true;
else
   % Checkbox is not checked-take approriate action
   timedep=false;
end
end
end