function [L,H,nbobstacle]=menu_geom(Choixpb)

global Lm Hm nbobst

% Valeur par defaut

if Choixpb==1 ,
    Hm='1'; Lm='1';
    nbobst='0';
else
    Hm='0.41'; Lm='2.2';
    nbobst='1';
end

hFigure = figure('Name', 'NS2D', 'MenuBar','none','numbertitle','off',...
                 'units','pixels','position',[600 600 485 300]);
                 
bgColor = get(hFigure,'Color');

uicontrol('Parent',hFigure,'style','text',...
   'BackgroundColor',bgColor,...
   'units','normalized','position',[0 0.85 1 0.1],...
   'string','Solveur Navier-Stokes 2D','FontSize',16);

%--------------------------------------------------------------------------
% Construction du menu 'Geometrie'
%--------------------------------------------------------------------------
hbgp = uibuttongroup('Parent',hFigure,'units','normalized',...
    'Position',[0 0.3 0.9 0.5],...
    'BackgroundColor',bgColor,...
    'Title','Géométrie (1)',...
    'FontSize',14);

uicontrol('Parent',hbgp,'style','text',...
    'string','Dimension du rectangle [0,L]x[0,H]',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.65 0.8 0.2]);

uicontrol('Parent',hbgp,'style','text','BackgroundColor',bgColor,...
    'string','L =','units','normalized','position',[0 0.4 0.06 0.15]);

uicontrol('Parent',hbgp,'style','edit',...
    'units','normalized','position',[0.07 0.4 0.1 0.2],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',Lm,'callback',@majL);

uicontrol('Parent',hbgp,'style','text','BackgroundColor',bgColor,...
    'string','H =','units','normalized','position',[0.25 0.4 0.06 0.15]);

uicontrol('Parent',hbgp,'style','edit',...
    'units','normalized','position',[0.32 0.4 0.1 0.2],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',Hm,'callback',@majH);

uicontrol('Parent',hbgp,'style','text',...
    'string','Nombre d''obstacles (ellipse/cercle) dans [0,L]x[0,H] =',...
    'BackgroundColor',bgColor,'HorizontalAlignment','left',...
    'units','normalized','position',[0 0.1 0.8 0.15]);

uicontrol('Parent',hbgp,'style','edit',...
    'units','normalized','position',[0.81 0.1 0.08 0.2],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',nbobst,'callback',@majnbobst);

%--------------------------------------------------------------------------
uicontrol('Parent',hFigure,'style','pushbutton',...
    'units','pixels',...
    'position',[212 20 60 30],...
    'string','OK',...
    'callback','close;');

uiwait

H=eval(Hm); L=eval(Lm); nbobstacle=eval(nbobst);

%--------------------------------------------------------------------------
function majL(source,eventdata)
  Lm=get(source,'String');
end
function majH(source,eventdata)
  Hm=get(source,'String');
end
function majnbobst(source,eventdata)
  nbobst=get(source,'String');
end

end