function [epxy,elgxy,angle_or,pas_h,dhmax]=menu_obst(nbobst)

global pxy lgxy angle cobst pas dh

% Valeurs par defaut

%pxy=num2cell(zeros(nbobst,2));
pxy=cell(nbobst,2);
lgxy=num2cell(0.05*ones(nbobst,2));

for i=1:2*nbobst,
    pxy{i}=num2str(pxy{i}); 
    lgxy{i}=num2str(lgxy{i}); 
end;

pxy(1,:)={'0.2', '0.2'};

angle=num2cell(zeros(nbobst,1));
for i=1:nbobst, angle{i}=num2str(angle{i});  end;

pas = '0.025';
dh='';
cobst=1;

hFigure = figure('Name', 'NS2D', 'MenuBar','none','numbertitle','off',...
                 'units','pixels','position',[600 600 485 550]);
                 
bgColor = get(hFigure,'Color');

uicontrol('Parent',hFigure,'style','text',...
   'BackgroundColor',bgColor,...
   'units','normalized','position',[0 0.9 1 0.05],...
   'string','Solveur Navier-Stokes 2D','FontSize',16);

%--------------------------------------------------------------------------
% Construction du menu 'Geometrie'
%--------------------------------------------------------------------------
hbgp = uibuttongroup('Parent',hFigure,'units','normalized',...
    'Position',[0.05 0.36 0.9 0.5],...
    'BackgroundColor',bgColor,...
    'Title','Géométrie (2)',...
    'FontSize',14);

     obstring='Obstacle 1'; 
     for i=2:nbobst  
        obstring=[obstring, '|Obstacle', num2str(i)];
     end
     
rb0=uicontrol('Parent',hbgp,'style','popupmenu',...
     'string',obstring,...
     'HorizontalAlignment','left','BackgroundColor',bgColor,...
     'units','normalized','position',[0 0.75 0.8 0.2]);

uicontrol('Parent',hbgp,'style','text',...
    'string','Position (x,y) du centre',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.72 0.44 0.07]);

uicontrol('Parent',hbgp,'style','text',...
    'string','x = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.635 0.06 0.06]);

rb1=uicontrol('Parent',hbgp,'style','edit',...
     'units','normalized','position',[0.07 0.62 0.2 0.1],...
     'BackgroundColor','white','HorizontalAlignment','left',...
     'string',pxy{cobst,1},'callback',@majpx);
 
 uicontrol('Parent',hbgp,'style','text',...
    'string','y = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0.35 0.635 0.06 0.06]);

rb2=uicontrol('Parent',hbgp,'style','edit',...
     'units','normalized','position',[0.42 0.62 0.2 0.1],...
     'BackgroundColor','white','HorizontalAlignment','left',...
     'string',pxy{cobst,2},'callback',@majpy);

uicontrol('Parent',hbgp,'style','text',...
    'string','Longueurs des demi-axes de l''ellipse',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.45 0.6 0.06]);

uicontrol('Parent',hbgp,'style','text',...
    'string','ax = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.345 0.08 0.06]);

rb3=uicontrol('Parent',hbgp,'style','edit',...
     'units','normalized','position',[0.08 0.33 0.2 0.1],...
     'BackgroundColor','white','HorizontalAlignment','left',...
     'string',lgxy{cobst,1},'callback',@majlgx);
 
 uicontrol('Parent',hbgp,'style','text',...
    'string','ay = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0.35 0.345 0.08 0.06]);

rb4=uicontrol('Parent',hbgp,'style','edit',...
     'units','normalized','position',[0.43 0.33 0.2 0.1],...
     'BackgroundColor','white','HorizontalAlignment','left',...
     'string',lgxy{cobst,2},'callback',@majlgy);

uicontrol('Parent',hbgp,'style','text',...
    'string','Angle d''orientation = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.15 0.33 0.06]);

rb5=uicontrol('Parent',hbgp,'style','edit',...
     'units','normalized','position',[0.35 0.13 0.2 0.1],...
     'BackgroundColor','white','HorizontalAlignment','left',...
     'string',angle{cobst},'callback',@majangle);

set(rb0,'callback',{@choixobst,rb1,rb2,rb3,rb4,rb5});

%--------------------------------------------------------------------------
% Construction du menu 'Maillage'
%--------------------------------------------------------------------------
hbgp = uibuttongroup('Parent',hFigure,'units','normalized',...
    'Position',[0.05 0.11 0.9 0.22],...
    'BackgroundColor',bgColor,...
    'Title','Paramètres du maillage',...
    'FontSize',14);
       
uicontrol('Parent',hbgp,'style','text',...
    'string','Pas de discrétisation   pas_h = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.6 0.46 0.2]);

uicontrol('Parent',hbgp,'style','edit',...
    'units','normalized','position',[0.47 0.59 0.2 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',pas,'callback',@majpas);

uicontrol('Parent',hbgp,'style','text',...
    'string','Qualité  d_h = ',...
    'HorizontalAlignment','left','BackgroundColor',bgColor,...
    'units','normalized','position',[0 0.24 0.22 0.2]);

uicontrol('Parent',hbgp,'style','edit',...
    'units','normalized','position',[0.23 0.23 0.2 0.25],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',dh,'callback',@majdh);

%--------------------------------------------------------------------------
uicontrol('Parent',hFigure,'style','pushbutton',...
    'units','pixels',...
    'position',[212 20 60 30],...
    'string','OK',...
    'callback','close;');

uiwait

epxy=zeros(nbobst,2);
elgxy=zeros(nbobst,2);
for i=1:2*nbobst,
    epxy(i)=eval(pxy{i});
    elgxy(i)=eval(lgxy{i});
end; 
for i=1:nbobst
    angle_or(i)=eval(angle{i});
end;

pas_h=eval(pas); 
if ~isempty(dh),
    dhmax=eval(dh);
else
    dhmax=[];
end;

%--------------------------------------------------------------------------
function majpx(source,eventdata)
pxy{cobst,1}=get(source,'String');
end

function majpy(source,eventdata)
pxy{cobst,2}=get(source,'String');
end

function majlgx(source,eventdata)
lgxy{cobst,1}=get(source,'String');
end

function majlgy(source,eventdata)
lgxy{cobst,2}=get(source,'String');
end

function majangle(source,eventdata)
angle{cobst}=get(source,'String');
end

function choixobst(source,eventdata,rb1,rb2,rb3,rb4,rb5)
cobst=get(source,'Value');
set(rb1,'String',pxy{cobst,1});
set(rb2,'String',pxy{cobst,2});
set(rb3,'String',lgxy{cobst,1});
set(rb4,'String',lgxy{cobst,2});
set(rb5,'String',angle{cobst});
end

function majpas(source,eventdata)
  pas=get(source,'String');
end
function majdh(source,eventdata)
  dh=get(source,'String');
end

end