function [nu,nbiter,dt,save_name,type_print]=menu_param(dt)

global visco nbmax dtmax save_dir type_affichage

% Valeur par défaut
visco=1e-3;
nbmax=150;
dtmax=dt;
save_dir='Results_NS';
type_affichage=1;

% Construction du menu
hFigure = figure('Name', 'NS2D', 'MenuBar','none','numbertitle','off',...
                 'units','pixels','position',[600 600 485 500]);
                 
bgColor = get(hFigure,'Color');

uicontrol('Parent',hFigure,'style','text',...
   'BackgroundColor',bgColor,...
   'units','normalized','position',[0 0.9 1 0.08],...
   'string','Solveur Navier-Stokes 2D','FontSize',16);

%--------------------------------------------------------------------------

h1 = uipanel('Parent',hFigure,'Position',[0.1 0.55  0.8 0.35],...
                      'BackgroundColor',bgColor,...
                      'Title','Paramètres numériques',...
                      'FontSize',14);
                 
uicontrol('Parent',h1,'style','text',...
    'units','normalized','position',[0.01 0.71 0.24 0.1],...
    'BackgroundColor',bgColor,'HorizontalAlignment','left',...
    'string','Viscosité  nu =');   
                 
uicontrol('Parent',h1,'style','edit',...
    'units','normalized','position',[0.26 0.7 0.3 0.15],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',num2str(visco,'%9.3e'),'callback',@majnu);
 
uicontrol('Parent',h1,'style','text',...
    'units','normalized','position',[0.01 0.44 0.5 0.1],...
    'BackgroundColor',bgColor,'HorizontalAlignment','left',...
    'string','Nombre d''itérations en temps =');   
                 
uicontrol('Parent',h1,'style','edit',...
    'units','normalized','position',[0.52 0.43 0.15 0.15],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',num2str(nbmax),'callback',@majnbiter);

uicontrol('Parent',h1,'style','text',...
    'units','normalized','position',[0.01 0.16 0.3 0.1],...
    'BackgroundColor',bgColor,'HorizontalAlignment','left',...
    'string','Pas de temps dt =');   
                 
uicontrol('Parent',h1,'style','edit',...
    'units','normalized','position',[0.32 0.15 0.3 0.15],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',num2str(dtmax),'callback',@majdt);

%-------------------------------------------------------------------------

h2=uibuttongroup('Parent',hFigure,'Position',[0.1 0.14 0.8 0.36],...
                      'BackgroundColor',bgColor,...
                      'Title','Sauvegarde et affichage','FontSize',14);     
                  
h2a=uipanel('Parent',h2,'Title','Répertoire de sauvegarde des fichiers :',...
    'BackgroundColor',bgColor,'FontSize',12,...
    'BorderWidth',0,'units','normalized','position',[0 0.5 1 0.4]);

uicontrol('Parent',h2a,'style','text',...
    'units','normalized','position',[0.1 0.4 0.04 0.35],...
    'BackgroundColor',bgColor,'HorizontalAlignment','left',...
    'string',' ./');

rb0=uicontrol('Parent',h2a,'style','edit',...
    'units','normalized','position',[0.15 0.4 0.6 0.45],...
    'BackgroundColor','white','HorizontalAlignment','left',...
    'string',save_dir,'callback',@majdir);

h2b=uibuttongroup('Parent',h2,'Title','Affichage','BackgroundColor',bgColor,...
    'FontSize',12,'BorderWidth',0,'units','normalized',...
    'position',[0 0.1 1 0.4]);

rb1=uicontrol('Parent',h2b,'style','radiobutton',...
    'units','normalized','position',[0.1 0.5 0.6 0.4],...
    'BackgroundColor',bgColor,...
    'string',' Vitesse');

rb2=uicontrol('Parent',h2b,'style','radiobutton',...
    'units','normalized','position',[0.1 0 0.6 0.4],...
    'BackgroundColor',bgColor,...
    'string',' Pression');

%set(hbgp,'SelectedObject',[]);  % Pas de selection
set(h2b,'SelectedObject',rb1);  % rb1 par default
type_affichage=1;
set(h2b,'SelectionChangeFcn',{@majprint,rb1,rb2});
set(h2b,'Visible','on');

%-------------------------------------------------------------------------

uicontrol('Parent',hFigure,'style','pushbutton',...
    'units','pixels',...
    'position',[212 20 60 30],...
    'string','OK',...
    'callback','close;');
uiwait

nu=visco; nbiter=nbmax; dt=dtmax;
save_name=save_dir; type_print=type_affichage;

%--------------------------------------------------------------------------
function majnu(source,eventdata)
    visco=str2double(get(source,'String'));
end

function majnbiter(source,eventdata)
    nbmax=str2double(get(source,'String'));
end

function majdt(source,eventdata)
    dtmax=str2double(get(source,'String'));
end

function majdir(source,eventdata)
    save_dir=get(source,'String');
end

function majprint(source,eventdata,rb1,rb2)
 if eventdata.NewValue==rb1, 
     type_affichage=1;
 else
     type_affichage=2;
 end
end

end
